﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Threading;

namespace pr242_1
{
    // Главный класс:
    class Program
    {
        // Статическое поле: 
        static int state = 0;
        // Статический метод: 
        static void run(bool type) {
            // Ссылка на объект потока,
            // в котором вызывается метод:
            Thread t = Thread.CurrentThread;
            // Отображение сообщения с названием потока: 
            Console.WriteLine("Поток " + t.Name + " запущен...");
            // Бесконечный цикл: 
            while(true) {
                // Изменение значения статического поля: 
                if (type) state++;
                else state--;
                // Поток приостанавливает выполнение: 
                Thread.Sleep(1000);
            }
        }

        // Главный метод: 
        static void Main()
        {
            // Получение ссылки на главный поток:
            Thread t = Thread.CurrentThread;
            // Название потока: 
            t.Name = "Base";
            // Отображение сообщения с названием потока: 
            Console.WriteLine("Главный поток {0} запущен...", t.Name); 
            // Отображение значения статического поля: 
            Console.WriteLine("Haчaльнoe значение: {0}", state);
            // Создание объекта для первого дочернего потока:
            Thread up = new Thread(() => run(true));
            // Создание объекта для второго дочернего потока:
            Thread down = new Thread(() => run(false));
            // Название для первого потока: 
            up.Name = "Alpha";
            // Приоритет для первого потока: 
            up.Priority = ThreadPriority.Highest;
            // Название для второго потока: 
            down.Name = "Bravo";
            // Приоритет для второго потока: 
            down.Priority = ThreadPriority.Lowest;
            // Запуск первого потока: 
            up.Start();
            // Запуск второго потока: 
            down.Start();
            // Приостановлено выполнение главного потока:
            Thread.Sleep(5000);
            // Завершение выполнения первого потока: 
            up.Abort();
            // Завершение выполнения второго потока: 
            down.Abort();
            // Итоговое значение статического поля:
            Console.WriteLine("Итоговое значение: {0}", state);
            // Сообщение о завершении главного потока:
            Console.WriteLine("Главный поток {0} завершен...", t.Name);
        }
    }
}
